//+------------------------------------------------------------------+
//|                                           FFS_Correlation_v1.mq4 |
//|                           Fixed by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |    
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 

This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY


*/

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White

//User Inputs Parameters
extern int IndexType = 3;
extern int cPeriod = 20;
extern int NoBars = 100;

//---- variables
double USDcorr[];
double USDpos[];
double USDneg[];
double normUSDpos[];
double normUSDneg[];


int init()
{
   IndicatorShortName("FFS_Correlation");
   
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,USDcorr);
   SetIndexLabel(0,"USDcorr");
   SetIndexBuffer(1,USDpos);
   SetIndexBuffer(2,USDneg);
   SetIndexBuffer(3,normUSDpos);
   SetIndexBuffer(4,normUSDneg);
   return(0);
}
//------------------------------------
int deinit()
{   
   return(0);
}


int start()
{      
 
   int limit;
   int counted_bars=IndicatorCounted();
   double Data1, Data2, Data3, Data4;
   double GBP0, EUR0, CHF0, JPY0;
     
     
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 
      
   for(int i=limit; i>=0; i--)
   {
   GBP0 = iClose("GBPUSD",0,NoBars+i);
   EUR0 = iClose("EURUSD",0,NoBars+i);
   CHF0 = iClose("USDCHF",0,NoBars+i);
   JPY0 = iClose("USDJPY",0,NoBars+i);
            
   Data1=iClose("EURUSD",0,i);
   Data2=iClose("GBPUSD",0,i);
   Data3=iClose("USDCHF",0,i);
   Data4=iClose("USDJPY",0,i);
    
      switch(IndexType)
      {
      case 1:
      //1. EUR/USD, USD/CHF"
         USDpos[i]=  (Data1 - EUR0 ) * 10000;
         USDneg[i]=  (Data3 - CHF0) * 10000;
         break;
      case 2:
      //2. EUR/USD, USD/CHF, GBP/USD
         USDpos[i]=  (Data1 - EUR0 ) * 10000 + (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data3 - CHF0) * 10000;
         break;
      case 3:
      //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
         USDpos[i]=  (Data1 - EUR0 ) * 10000+ (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data3 - CHF0) * 10000  + (Data4 - JPY0) * 100  ;
         break;
      case 4:
      //4. EUR/USD, USD/CHF, USD/JPY
         USDpos[i]=  (Data1 - EUR0 ) * 10000;
         USDneg[i]=  (Data3 - CHF0) * 10000  + (Data4 - JPY0) * 100  ;
         break;
      case 5:
      //5. EUR/USD, GBP/USD, USD/JPY
         USDpos[i]=  (Data1 - EUR0 ) * 10000+ (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data4 - JPY0) * 100  ;
         break;
      case 6:
      //6. USD/CHF, GBP/USD
         USDpos[i]=  (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data3 - CHF0) * 10000 ;
         break;
      case 7:
      //7. USD/CHF, GBP/USD, USD/JPY
         USDpos[i]=  (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data3 - CHF0) * 10000  + (Data4 - JPY0) * 100  ;
         break;  
      case 8:
      //8. GBP/USD, USD/JPY 
         USDpos[i]=  (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data4 - JPY0) * 100  ;
         break;
      default:
         USDpos[i]=  (Data1 - EUR0 ) * 10000+ (Data2 - GBP0) * 10000 ;
         USDneg[i]=  (Data3 - CHF0) * 10000  + (Data4 - JPY0) * 100  ;
         break;
      }
       
       double MaxPos=-10000000, MinPos=10000000;
       double MaxNeg=-10000000, MinNeg=10000000;
       
      for ( int k=0; k<=NoBars-1;k++)
      {
         if( USDpos[i+k] > MaxPos) MaxPos = USDpos[i+k];
         if( USDpos[i+k] < MinPos) MinPos = USDpos[i+k];
         if( USDneg[i+k] > MaxNeg) MaxNeg = USDneg[i+k];
         if( USDneg[i+k] < MinNeg) MinNeg = USDneg[i+k];
      }
      
      if (MaxPos - MinPos != 0) normUSDpos[i] = 100*(USDpos[i]-MinPos)/(MaxPos-MinPos);  
      if (MaxNeg - MinNeg != 0) normUSDneg[i] = 100*(USDneg[i]-MinNeg)/(MaxNeg-MinNeg); 
   }
       
   for(i=limit; i>=0; i--)
   {       
   double SumXY  = 0;
   double SumX   = 0;
   double SumX2  = 0;
   double SumY   = 0;
   double SumY2  = 0;
   
      for(k=0;k<=cPeriod-1;k++) 
      {
      SumXY += normUSDpos[i+k]*normUSDneg[i+k];
      SumX  += normUSDpos[i+k];
      SumY  += normUSDneg[i+k];
      SumX2 += normUSDpos[i+k]*normUSDpos[i+k];
      SumY2 += normUSDneg[i+k]*normUSDneg[i+k];
      }
   
   if((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod)!=0) 
   USDcorr[i] = (SumXY - SumX*SumY/cPeriod)/MathPow((SumX2-SumX*SumX/cPeriod)*(SumY2-SumY*SumY/cPeriod),0.5); 
       
   }
   return(0);
}
//+------------------------------------------------------------------+